﻿module ini;

private import std.stdio;
private import std.file;
private import std.string;

class ini{
	char[][char[]][char[]] Ini;
	static char[] DefaultIniFileName = "inibackup";
	
	this(char[] file){
		if(!exists(file)){
			if( !exists( DefaultIniFileName ) )
				throw new Exception( " no ini file: "~file );

			debug writefln("IniFile Not Found - Loaded Default");
			auto void[] d = read(DefaultIniFileName);
			write(file,d);
		}
		
		char[][] data = splitlines(cast(char[])read(file));
		char[] sec;
		uint temp;
		
		foreach(char[] line;data)
		{
			temp = find(line,"//");
			if( temp != -1 ){
				line.length = temp;
			}
			
			if(find(line,"[")==0 && (rfind(line,"]")==line.length-1)){
				sec = line;
				sec = replace(sec,"[","");
				sec = replace(sec,"]","");
				continue;
			}
			
			if(sec == null)continue;
			
			if(find(line,"=")!=-1){
				int eq = find( line, "=" );
				Ini[sec][line[0..eq]] = line[eq+1..$];
			}
		}
	}
	
	char[] value( char[] k, char[] l )
	{
		if( k in Ini )
		{
			return *( l in Ini[k] );
		}
		
		return null;
	}
	
	void Show(){
		writefln("-------------- Ini Data ---------------");
		foreach(char[] s;Ini.keys){
			writefln("["~s~"]");
			foreach(char[] k;Ini[s].keys)
				writefln("\t"~k~" = "~Ini[s][k]~"\n");
		}
		printf("---------------------------------------");
	}
}